GNU bug report logs - #6718
23.2; Should align glyphs according to grid in ansi-term

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Jonathan Kleinehellefort <jk@HIDDEN>; Keywords: confirmed; merged with #44664; dated Sat, 24 Jul 2010 16:10:03 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
Forcibly Merged 6718 44664. Request was from Stefan Kangas <stefan@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 6718 <at> debbugs.gnu.org:


Received: (at 6718) by debbugs.gnu.org; 19 Nov 2020 15:32:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 19 10:32:49 2020
Received: from localhost ([127.0.0.1]:40651 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kflvV-0006dd-Fa
	for submit <at> debbugs.gnu.org; Thu, 19 Nov 2020 10:32:49 -0500
Received: from mail-ej1-f43.google.com ([209.85.218.43]:39850)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <stefankangas@HIDDEN>) id 1kflvT-0006dK-Al
 for 6718 <at> debbugs.gnu.org; Thu, 19 Nov 2020 10:32:48 -0500
Received: by mail-ej1-f43.google.com with SMTP id s25so8491121ejy.6
 for <6718 <at> debbugs.gnu.org>; Thu, 19 Nov 2020 07:32:47 -0800 (PST)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:in-reply-to:references:mime-version:date
 :message-id:subject:to:cc;
 bh=Ubul2HX6i2Am3SGUqkFF3g0b0/3gGG5x94IbBwpZYZ8=;
 b=qNEfmETRHpBmD2ILw7WqBdHvEtYn12kae9E8J5Iadz2EJVP8DO+OsqzcF5Av5/w8QX
 hjvcNggvxR3ykRF7KBoFhcRA5vHIELimKzyAuVR+1smu8KtpuX7QxyxGOg0QwRzcNT7J
 Uw3NNfcC1W6+ekoCUU6ckuorEj2nm4SFM/Q+txSdHw0JQkx7ydMeZz2JWenD+oaDfIjM
 JgJvg9rHjK8DdF74nm3vMaS1tu5IadlQP3GpXBhsx8TSD0ymLVRE17lrN7XTs5wsnBVv
 hPz8zCTD8JQQINn7/zJdtwfQXtAEruxXxVPZF4lFXOU6rT/8Uqi5WtBzkzXufBzclz27
 VP7A==
X-Gm-Message-State: AOAM531CdZ/AL92+mXU2onwPpuqCCOiF7zww3wr/DKa4VMrCgrS+qoC9
 p6DBNaO5qLIPTeIBsUIKYP2aPHRl4LNT4FjPMug=
X-Google-Smtp-Source: ABdhPJwMIec7iWdzljanC793VOmKOId9exzcjVh5yyi5Pw734HFSx4rAJ4Dmkyg5fbOr3J36Bn7S8hEST7x48UW08cE=
X-Received: by 2002:a17:906:d9d0:: with SMTP id
 qk16mr2317143ejb.420.1605799961583; 
 Thu, 19 Nov 2020 07:32:41 -0800 (PST)
Received: from 753933720722 named unknown by gmailapi.google.com with
 HTTPREST; Thu, 19 Nov 2020 07:32:41 -0800
From: Stefan Kangas <stefan@HIDDEN>
In-Reply-To: <83y2ixo18r.fsf@HIDDEN>
References: <87k4ok27p4.fsf@HIDDEN>
 <CADwFkmm7X-91MoBFrH_Mj7aNHdi7fkYcOV1XUfErWv_OgWffNA@HIDDEN>
 <871rgpyboy.fsf@HIDDEN> <83y2ixo18r.fsf@HIDDEN>
MIME-Version: 1.0
Date: Thu, 19 Nov 2020 07:32:41 -0800
Message-ID: <CADwFkm=3Woi79NMnYZAM5jdq_m1B=CnJVwJXdvy7N_QL+VX4+A@HIDDEN>
Subject: Re: bug#6718: 23.2; Should align glyphs according to grid in ansi-term
To: Eli Zaretskii <eliz@HIDDEN>, "Basil L. Contovounesios" <contovob@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 6718
Cc: jk@HIDDEN, 6718 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

forcemerge 6718 44664
thanks

Eli Zaretskii <eliz@HIDDEN> writes:

>> Is there any overlap here with https://debbugs.gnu.org/44664?
>
> Yes, it's the same issue.

OK; merging.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#6718; Package emacs. Full text available.

Message received at 6718 <at> debbugs.gnu.org:


Received: (at 6718) by debbugs.gnu.org; 19 Nov 2020 14:44:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 19 09:44:28 2020
Received: from localhost ([127.0.0.1]:38670 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kflAi-0002qE-DN
	for submit <at> debbugs.gnu.org; Thu, 19 Nov 2020 09:44:28 -0500
Received: from eggs.gnu.org ([209.51.188.92]:51648)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1kflAh-0002q2-6i
 for 6718 <at> debbugs.gnu.org; Thu, 19 Nov 2020 09:44:27 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:53106)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1kflAa-0004bU-V7; Thu, 19 Nov 2020 09:44:20 -0500
Received: from [176.228.60.248] (port=3032 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1kflAa-0007qk-C3; Thu, 19 Nov 2020 09:44:20 -0500
Date: Thu, 19 Nov 2020 16:44:04 +0200
Message-Id: <83y2ixo18r.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: "Basil L. Contovounesios" <contovob@HIDDEN>
In-Reply-To: <871rgpyboy.fsf@HIDDEN> (contovob@HIDDEN)
Subject: Re: bug#6718: 23.2; Should align glyphs according to grid in ansi-term
References: <87k4ok27p4.fsf@HIDDEN>
 <CADwFkmm7X-91MoBFrH_Mj7aNHdi7fkYcOV1XUfErWv_OgWffNA@HIDDEN>
 <871rgpyboy.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 6718
Cc: 6718 <at> debbugs.gnu.org, jk@HIDDEN, stefan@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: "Basil L. Contovounesios" <contovob@HIDDEN>
> Date: Thu, 19 Nov 2020 08:48:13 +0000
> Cc: Jonathan Kleinehellefort <jk@HIDDEN>, 6718 <at> debbugs.gnu.org
> 
> >> Expected result:
> >>
> >> Glyphs should be aligned in a grid.
> >>
> >> Using a more comprehensive font (e.g. DejaVu Sans Mono) does not solve
> >> this completely, as you can still get the same problem with e.g. Chinese
> >> characters.
> >
> > Is there really anything that can be done about this, besides a complete
> > redesign of how fonts work in Emacs?
> 
> Is there any overlap here with https://debbugs.gnu.org/44664?

Yes, it's the same issue.

I think a good way forward is for someone to investigate which fonts
are typically used in xterm for CJK and other "unusual" scripts,
including characters reported in bug#44664, then we could perhaps see
how to improve the situation in Emacs in this respect.  I don't see
any easy ways to "fix" this except by clever font configuration, and
I'd be interested to know whether xterm does anything beyond using
fonts that are known to DTRT.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#6718; Package emacs. Full text available.

Message received at 6718 <at> debbugs.gnu.org:


Received: (at 6718) by debbugs.gnu.org; 19 Nov 2020 08:48:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 19 03:48:24 2020
Received: from localhost ([127.0.0.1]:38093 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kffc7-0004NU-Hf
	for submit <at> debbugs.gnu.org; Thu, 19 Nov 2020 03:48:24 -0500
Received: from mail-wm1-f49.google.com ([209.85.128.49]:51747)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <contovob@HIDDEN>) id 1kffc5-0004NF-Kp
 for 6718 <at> debbugs.gnu.org; Thu, 19 Nov 2020 03:48:22 -0500
Received: by mail-wm1-f49.google.com with SMTP id a186so3549937wme.1
 for <6718 <at> debbugs.gnu.org>; Thu, 19 Nov 2020 00:48:21 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=tcd-ie.20150623.gappssmtp.com; s=20150623;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=hKmqe+9BbqVLSCemuQ6nJMvdtj3c0x0/KYrECcJTSuM=;
 b=fH5IcoADAujmWSzXKKrXT34rxat/UVGSDLHOuYkbC6QpuFGm4DV8tgsKRBrgzEOwzc
 2P0caYxxv/fhEL8fHq6uBawP3WOIBgoCwSACjYrKWhs5Eixl+0tws7IvOzzmpq4VHkR7
 +699jbGhuAaYdVJBToH3iu5/xIA7MLY1pgFe4F9kMR4J3mNObeWhyxso8pHJ4tVDxKO8
 S1JU76iGLwyyEI5lCUFVJPcP7xco8GJ8MFthUaL7puR7V8VjhJk9uxEZckCaQ6PGRDra
 35DBfAwevjDNhyGVNggP9F0743ocZ6Lvl3uLFGyKAPqigU2gY4ssl5Vx+ggpqLlZKSzW
 w4Gw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=hKmqe+9BbqVLSCemuQ6nJMvdtj3c0x0/KYrECcJTSuM=;
 b=EZL+YSItdN46qUQdMzhmUcnekhlSbso+RmN6DeTn6GYjvyft+SutcH9U/gNfAfC+m7
 OhFSC8tQN/OIOvpb8FZJWoPK/1cvqNoEVfoJ+o4JiRN6kCyNsONTBy/I8QtjTdMjyfDO
 +ybJ+3dheYkrplxEy4BZ6MgegsK7w1SwNTVM1oam+s0PGIp0j9Gzr3nfU0kDFNAOyZJJ
 fs4e7XSuKecFawZjyaEzSdBQCU/YO1ZmB958mQOjBUTTxr95X3y7xApTAZcpSVqIShsA
 ei8wkCkh/XWBa4z3SrePAelpC4UYf9vgeyKCM99aMFYBGCHllg7CMNMxumXtByFtYByC
 iPnQ==
X-Gm-Message-State: AOAM532o/rVqahaw6FRTiM50yLSZOdJ2i+gwiThapsXkN6PPNoaf+1/r
 cB+HC1YweD7SUBBnNjBinV1c1NXuyL3LKBDl
X-Google-Smtp-Source: ABdhPJxKzwtxyiMsx8UDllJ5hPJOgIbfqUEYCsIzj7jIs5t8M2Sl4vAhZ9qYTX4+J4TZersyfUOCNA==
X-Received: by 2002:a05:600c:255:: with SMTP id
 21mr3365450wmj.69.1605775696063; 
 Thu, 19 Nov 2020 00:48:16 -0800 (PST)
Received: from localhost ([2a02:8084:20e2:c380:92bd:1bfd:38fc:fae2])
 by smtp.gmail.com with ESMTPSA id v189sm9351418wmg.14.2020.11.19.00.48.15
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 19 Nov 2020 00:48:15 -0800 (PST)
From: "Basil L. Contovounesios" <contovob@HIDDEN>
To: Stefan Kangas <stefan@HIDDEN>
Subject: Re: bug#6718: 23.2; Should align glyphs according to grid in ansi-term
References: <87k4ok27p4.fsf@HIDDEN>
 <CADwFkmm7X-91MoBFrH_Mj7aNHdi7fkYcOV1XUfErWv_OgWffNA@HIDDEN>
Date: Thu, 19 Nov 2020 08:48:13 +0000
In-Reply-To: <CADwFkmm7X-91MoBFrH_Mj7aNHdi7fkYcOV1XUfErWv_OgWffNA@HIDDEN>
 (Stefan Kangas's message of "Wed, 18 Nov 2020 20:25:50 -0800")
Message-ID: <871rgpyboy.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 6718
Cc: Jonathan Kleinehellefort <jk@HIDDEN>, 6718 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Stefan Kangas <stefan@HIDDEN> writes:

> Jonathan Kleinehellefort <jk@HIDDEN> writes:
>
>> I came across this when I tried using the font Inconsolata inside
>> ansi-term.  Inconsolata does not cover a couple of special Unicode
>> characters, some of which frequently show up in the output of various
>> terminal applications.
>>
>> Emacs will then fall back on some other font with completely different
>> geometry for those, destroying the grid layout of the buffer.
>>
>> Steps to reproduce:
>>
>>  1. run "emacs -Q"
>>  2. M-x term
>>  4. type "pstree" into the shell
>>  5. Choose "Inconsolata" as your font
>>
>> Result:
>>
>> Characters now have non-uniform width and height. Note that the pretty
>> tree drawing gets destroyed.
>>
>> Expected result:
>>
>> Glyphs should be aligned in a grid.
>>
>> Using a more comprehensive font (e.g. DejaVu Sans Mono) does not solve
>> this completely, as you can still get the same problem with e.g. Chinese
>> characters.
>
> Is there really anything that can be done about this, besides a complete
> redesign of how fonts work in Emacs?

Is there any overlap here with https://debbugs.gnu.org/44664?

-- 
Basil




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#6718; Package emacs. Full text available.

Message received at 6718 <at> debbugs.gnu.org:


Received: (at 6718) by debbugs.gnu.org; 19 Nov 2020 04:26:00 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 18 23:26:00 2020
Received: from localhost ([127.0.0.1]:37483 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kfbWC-0003pU-IH
	for submit <at> debbugs.gnu.org; Wed, 18 Nov 2020 23:26:00 -0500
Received: from mail-ej1-f46.google.com ([209.85.218.46]:37932)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <stefankangas@HIDDEN>) id 1kfbW8-0003pC-Sd
 for 6718 <at> debbugs.gnu.org; Wed, 18 Nov 2020 23:25:59 -0500
Received: by mail-ej1-f46.google.com with SMTP id a16so5976996ejj.5
 for <6718 <at> debbugs.gnu.org>; Wed, 18 Nov 2020 20:25:56 -0800 (PST)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:in-reply-to:references:user-agent
 :mime-version:date:message-id:subject:to:cc;
 bh=xCg5GGSaeTZl7FK4mqEGPNW+qVHK51nN+Rlv0nNRmCY=;
 b=dFlegexYbE4biLdNPzEwA8YOyaMIjvuIR7W7R1JLZyZe5Uxec8EJ91Gq9QxPZCMFJ2
 +Zi8kJsU6V3GpterKG7XRYJLa8lcBic5M6arVu17XxHyQlPrwfc6YOzooyypnzRACknb
 QHQs/aZpZPgMUrrKj7l4KVE1p2p3GA6Vz/LONzPZq0MVqX9JWiT/WV8olATF9a+XhNg7
 dXoSOgPKEAkNqlfNP7X9usZx0dcM2fSGWmCXR9EtFwq8Vs9gjHGzwHI8lgbF0cvbyXJF
 wMjFE/66p0nWZx3gdqCgyAlDCovcq06fNB+0eORqbujRY3Mz+HEyutyfUgooUHpoNfW9
 jg7Q==
X-Gm-Message-State: AOAM530B5hhf3SEurLgHHTGsnfMUnALyF3qhZEH91PWZWEAfRDC0JMtx
 LiMvBgYr9niwlSf2n9fJr7Wt7qvLkMndtAEcEnw=
X-Google-Smtp-Source: ABdhPJwXTPmizJCJpe3WWyibzUd+LvRFRrlUMWEQC/Z8FMi6lwoZGIiuIvpheeEwbHw0zrX+ld6mjr/46iBo8UHFOd0=
X-Received: by 2002:a17:906:d9d0:: with SMTP id
 qk16mr297365ejb.420.1605759950915; 
 Wed, 18 Nov 2020 20:25:50 -0800 (PST)
Received: from 753933720722 named unknown by gmailapi.google.com with
 HTTPREST; Wed, 18 Nov 2020 20:25:50 -0800
From: Stefan Kangas <stefan@HIDDEN>
In-Reply-To: <87k4ok27p4.fsf@HIDDEN> (Jonathan Kleinehellefort's message of
 "Sat, 24 Jul 2010 17:57:59 +0200")
References: <87k4ok27p4.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Date: Wed, 18 Nov 2020 20:25:50 -0800
Message-ID: <CADwFkmm7X-91MoBFrH_Mj7aNHdi7fkYcOV1XUfErWv_OgWffNA@HIDDEN>
Subject: Re: bug#6718: 23.2; Should align glyphs according to grid in ansi-term
To: Jonathan Kleinehellefort <jk@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 6718
Cc: 6718 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

Jonathan Kleinehellefort <jk@HIDDEN> writes:

> I came across this when I tried using the font Inconsolata inside
> ansi-term.  Inconsolata does not cover a couple of special Unicode
> characters, some of which frequently show up in the output of various
> terminal applications.
>
> Emacs will then fall back on some other font with completely different
> geometry for those, destroying the grid layout of the buffer.
>
> Steps to reproduce:
>
>  1. run "emacs -Q"
>  2. M-x term
>  4. type "pstree" into the shell
>  5. Choose "Inconsolata" as your font
>
> Result:
>
> Characters now have non-uniform width and height. Note that the pretty
> tree drawing gets destroyed.
>
> Expected result:
>
> Glyphs should be aligned in a grid.
>
> Using a more comprehensive font (e.g. DejaVu Sans Mono) does not solve
> this completely, as you can still get the same problem with e.g. Chinese
> characters.

Is there really anything that can be done about this, besides a complete
redesign of how fonts work in Emacs?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#6718; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 24 Jul 2010 16:09:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 24 12:09:58 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OchIU-0007Sa-3B
	for submit <at> debbugs.gnu.org; Sat, 24 Jul 2010 12:09:58 -0400
Received: from mail.gnu.org ([199.232.76.166] helo=mx10.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <jk@HIDDEN>) id 1Och8l-0007OF-85
	for submit <at> debbugs.gnu.org; Sat, 24 Jul 2010 11:59:56 -0400
Received: from lists.gnu.org ([199.232.76.165]:39255)
	by monty-python.gnu.org with esmtps
	(TLS-1.0:DHE_RSA_AES_256_CBC_SHA1:32) (Exim 4.60)
	(envelope-from <jk@HIDDEN>) id 1Och8l-0007Hn-OT
	for submit <at> debbugs.gnu.org; Sat, 24 Jul 2010 11:59:55 -0400
Received: from [140.186.70.92] (port=39933 helo=eggs.gnu.org)
	by lists.gnu.org with esmtp (Exim 4.43) id 1Och8k-0006Df-4m
	for bug-gnu-emacs@HIDDEN; Sat, 24 Jul 2010 11:59:55 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.1 (2010-03-16) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00,T_RP_MATCHES_RCVD
	autolearn=unavailable version=3.3.1
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.69)
	(envelope-from <jk@HIDDEN>) id 1Och8i-0001IU-Lw
	for bug-gnu-emacs@HIDDEN; Sat, 24 Jul 2010 11:59:53 -0400
Received: from molb.org ([188.40.175.106]:35706)
	by eggs.gnu.org with esmtp (Exim 4.69) (envelope-from <jk@HIDDEN>)
	id 1Och8i-0001Hz-HL
	for bug-gnu-emacs@HIDDEN; Sat, 24 Jul 2010 11:59:52 -0400
Received: from localhost (localhost [127.0.0.1])
	by molb.org (Postfix) with ESMTPSA id 60BCB200E0BA
	for <bug-gnu-emacs@HIDDEN>; Sat, 24 Jul 2010 17:59:48 +0200 (CEST)
From: Jonathan Kleinehellefort <jk@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 23.2; Should align glyphs according to grid in ansi-term
Date: Sat, 24 Jul 2010 17:57:59 +0200
Message-ID: <87k4ok27p4.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6 (newer, 3)
X-detected-operating-system: by monty-python.gnu.org: GNU/Linux 2.6,
	seldom 2.4 (older, 4)
X-Spam-Score: -4.0 (----)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Sat, 24 Jul 2010 12:09:57 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -5.3 (-----)

I came across this when I tried using the font Inconsolata inside
ansi-term.  Inconsolata does not cover a couple of special Unicode
characters, some of which frequently show up in the output of various
terminal applications.

Emacs will then fall back on some other font with completely different
geometry for those, destroying the grid layout of the buffer.

Steps to reproduce:

 1. run "emacs -Q"
 2. M-x term
 4. type "pstree" into the shell
 5. Choose "Inconsolata" as your font

Result:

Characters now have non-uniform width and height. Note that the pretty
tree drawing gets destroyed.

Expected result:

Glyphs should be aligned in a grid.

Using a more comprehensive font (e.g. DejaVu Sans Mono) does not solve
this completely, as you can still get the same problem with e.g. Chinese
characters.



In GNU Emacs 23.2.1 (i486-pc-linux-gnu, GTK+ Version 2.20.0)
 of 2010-05-16 on raven, modified by Debian
Windowing system distributor `The X.Org Foundation', version 11.0.10707000
configured using `configure  '--build' 'i486-linux-gnu' '--build' 'i486-linux-gnu' '--prefix=/usr' '--sharedstatedir=/var/lib' '--libexecdir=/usr/lib' '--localstatedir=/var/lib' '--infodir=/usr/share/info' '--mandir=/usr/share/man' '--with-pop=yes' '--enable-locallisppath=/etc/emacs23:/etc/emacs:/usr/local/share/emacs/23.2/site-lisp:/usr/local/share/emacs/site-lisp:/usr/share/emacs/23.2/site-lisp:/usr/share/emacs/site-lisp:/usr/share/emacs/23.2/leim' '--with-x=yes' '--with-x-toolkit=gtk' '--with-toolkit-scroll-bars' 'build_alias=i486-linux-gnu' 'CFLAGS=-DDEBIAN -g -O2' 'LDFLAGS=-g' 'CPPFLAGS=''

Important settings:
  value of $LC_ALL: nil
  value of $LC_COLLATE: nil
  value of $LC_CTYPE: nil
  value of $LC_MESSAGES: nil
  value of $LC_MONETARY: nil
  value of $LC_NUMERIC: nil
  value of $LC_TIME: nil
  value of $LANG: de_DE.UTF-8
  value of $XMODIFIERS: nil
  locale-coding-system: utf-8-unix
  default enable-multibyte-characters: t

Major mode: Term




Acknowledgement sent to Jonathan Kleinehellefort <jk@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:
bug#6718; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Thu, 19 Nov 2020 15:45:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.